#ifndef QANIMTT_H
#define QANIMTT_H

#include <qwidget.h>
#include <qpixmap.h>
#include <qtimer.h>

class QPaintEvent;

class QTimer;

class QAnimTT : public QWidget
{
    Q_OBJECT
public:
    QAnimTT( QWidget * parent );

    enum Effect { None, Scale, Shear, Rotate };
    void display( const QString & message, Effect eff = Scale, int durationMs = 8000 );


    virtual void hide();

protected:
    void paintEvent( QPaintEvent * e );
    void mousePressEvent( QMouseEvent * e );
    QPixmap scale();
    QPixmap shear();
    QPixmap rotate();
    void displayInternal();

protected slots:
    void internalUpdate();
private:
    QString m_message;
    QPixmap m_pixmap;
    QPixmap m_animPix;
    Effect m_effect;

    int m_rotate;
    double m_shearX, m_shearY;
    bool m_return;

    QTimer m_timer;
    QTimer m_frameTimer;
    bool m_dirty;
};

#endif
